<?php
/*
 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2007, Ryan Djurovich

 Website Baker is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Website Baker is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 -----------------------------------------------------------------------------------------
  Code snippet LastComments for Website Baker v2.6.x
  Licencsed under GNU, written by Chio
  The snippet is based on snippet AnyNews
 -----------------------------------------------------------------------------------------
*/

// function to display news comments on every page via (invoke function from template or code page)

if (!function_exists('display_lastcomments')) {
	function display_lastcomments( $readmore_text='More..', $no_comments='No Comments', $max_lastcomments = 5, $max_chars=1000, $max_chars_per=200, $active_only=1) {
		
		// register outside object
		global $database;
		global $wb;

		// convert all numeric inputs to integer variables		
		$max_lastcomments = (int) $max_lastcomments;
		$max_chars = (int) $max_chars;
		$max_chars_per = (int) $max_chars_per;
		$active_only = (int) $active_only;
		
		
		$query = "SELECT * FROM " .TABLE_PREFIX ."mod_news_comments ORDER BY comment_id DESC LIMIT 0, $max_lastcomments;";
		
		// make database query and obtain number of comments found
		$result = $database->query($query);
		$number_comments = $result->numRows();      

		
		echo "\n<!-- Display news comments -->\n";
		
		$output = "";
		$now_chars = 0;
		if ($number_comments) {
			 while($data = $result->fetchRow()) {
			 
			 	$query = "SELECT link,active,page_id,section_id,group_id FROM " .TABLE_PREFIX ."mod_news_posts WHERE post_id=". $data['post_id'].";";
			 	$postresult = $database->query($query);
			 	$postdata = $postresult->fetchRow();
				
			 	//check if post is active:
				 if ($active_only==1) { 
				 	if ($postdata['active'] <> 1) {continue;}
			 
				 	//check if group is active:
					if ($postdata['group_id'] <> 0) {
						$query = "SELECT active FROM " .TABLE_PREFIX ."mod_news_groups WHERE group_id=". $postdata['group_id'].";";
			 			$groupresult = $database->query($query);
			 			$groupdata = $groupresult->fetchRow();						
						if ($groupdata['active'] <> 1) {continue;}
					}
				}
				
				
			 
		 		$the_comment = $data['comment'];				
				$data['title'] = strip_tags($data['title']);
				$the_comment = strip_tags($the_comment);
				if ($the_comment=='') {continue;}
				 
				 //check the number of chars; this is NOT very exact:
				$is_chars = strlen($the_comment);
				if ($is_chars > $max_chars_per) {$is_chars = $max_chars_per + 1;}
				if (($now_chars + $is_chars) > $max_chars) {break;} //too much chars
				
				
				$now_chars = $now_chars + $is_chars;
				
				if ($is_chars >  $max_chars_per) {
					$pos = strpos($the_comment, " ", $max_chars_per);					
					if ($pos > 0) {$the_comment = substr($the_comment, 0,  $pos) . '...'; }				
				}
				//make output line
				$the_line = "<h3>".$data['title']."</h3>\n<p class=\"comment\">".$the_comment."</p>\n";
				if ($postdata['active'] == 1) {
					$the_line .= '<p class="commentlink"><a href="'.page_link($postdata['link']).'" rel="nofollow">'.$readmore_text.'</a>'; 
				} else {
					$the_line .= '<p class="commentlink">'.$postdata['link'].' (not active)'; 
				}
				
				//Edit link if user is authenticated:
				if ($wb->is_authenticated()) {
					$the_line .= ' | <a href="'.WB_URL.'/modules/news/modify_post.php?page_id='.$postdata['page_id'].'&section_id='.$postdata['section_id'].'&post_id='.$data['post_id'].'">Edit</a>';
				}				
		 		$output .= $the_line."</p><hr/>";
				
			} //end while
			echo '<div id="display_lastcomments">' .$output ."</div>\n";
		} else {
			echo '<div id="display_lastcomments">'.$no_comments ."</div>\n";
		} //end if($number_comments)
	}
	
}

?>